;  8 
;		0-50(35)  = 0,01 	=0,05
;	0-500(255)   100 =0,5
;
#include	"P16F676.inc"
			__config	_MCLRE_OFF & _EXTRC_OSC_CLKOUT & _BODEN & _CP_OFF & _CPD_OFF & _PWRTE_ON & _WDT_ON

			cblock	0x20
			adL
			adM
			adH
			adHH
			adCnt				;-   
			adZ					;,   
			FLAGS
			LCD_tmp
			W_tmp
			S_tmp
			F_tmp
			ScalePos			;   = U / 15
			ScaleSym			;   (0-3)
			cnt
			tmp
			metrCnt
			endc
			
#define	LCD			PORTC		
#define	b_RS		PORTC, 4
#define	b_E			PORTC, 5
#define	fl_lcdstep	FLAGS, 7
#define	fl_tmp		FLAGS, 3		;      
#define	fl_digval	FLAGS, 6		;     U, I


			org		0x0000
			bcf		STATUS, RP0			;bank 0
			movlw	.7					;
			movwf	CMCON				;Comparators off
			goto	START
INTERUPT	movwf	W_tmp
			swapf	STATUS, W
			bcf		STATUS, RP0			;bank 0
			movwf	S_tmp
			movf	FSR, W
			movwf	F_tmp
			
			movf	F_tmp, W
			movwf	FSR
			swapf	S_tmp, W
			movwf	STATUS
			swapf	W_tmp, F
			swapf	W_tmp, W
			retfie
loadsym		
			bcf		b_RS			; Select Instructions Register.
			movlw	b'01000000'		; CGRAM
			call	ToLCD
			bsf		b_RS			; Select Instructions Register.
			clrf	tmp
load		movf	tmp, W
			call	sym_tab
			call	ToLCD
			incf	tmp, F
			movf	tmp, W
			sublw	.32				;8    *4 =32
			btfss	STATUS, Z	
			goto	load

			bcf		b_RS				; 
			movlw	b'10000000'			; 0  1 
			call	ToLCD
			bsf		b_RS				;Select Instructions Register.
			
			return
			
sym_tab		addwf	PCL, F
			retlw	b'00010000'		;0
			retlw	b'00010000'
			retlw	b'00010000'
			retlw	b'00010000'
			retlw	b'00010000'
			retlw	b'00010000'
			retlw	b'00010000'
			retlw	b'00010000'		;
			retlw	b'00011000'		;1
			retlw	b'00011000'
			retlw	b'00011000'
			retlw	b'00011000'
			retlw	b'00011000'
			retlw	b'00011000'
			retlw	b'00011000'
			retlw	b'00011000'		;
			retlw	b'00011100'		;2
			retlw	b'00011100'
			retlw	b'00011100'
			retlw	b'00011100'
			retlw	b'00011100'
			retlw	b'00011100'
			retlw	b'00011100'
			retlw	b'00011100'		;
			retlw	b'00011110'		;3
			retlw	b'00011110'
			retlw	b'00011110'
			retlw	b'00011110'
			retlw	b'00011110'
			retlw	b'00011110'
			retlw	b'00011110'
			retlw	b'00011110'		;

START		
			bsf		STATUS, RP0			;bank 1
;			call	0x3FF				;
;			movwf	OSCCAL				;
			clrf	TRISC				;   			
			movlw	0xFF				;    
			movwf	PORTA				;
			movlw	b'00000011'			;AN0, AN1 set to analog input
			movwf	ANSEL
			movlw	b'01010000'			;   (Tosc/16)8/16=2us
			movwf	ADCON1				;
			movlw	b'11010000'			; 1:2  TMR0( )
			movwf	OPTION_REG			;	
			bcf		STATUS, RP0			;bank 0
			bsf		ADCON0, ADFM		;   
			bsf		ADCON0, ADON		; 
										;   C hold >20us  . 
			movlw	b'00110100'			;TMR1 1:8 OFF
			movwf	T1CON				;
					
			call	LCD_init
			call	loadsym				; 
			bsf		b_RS				;  LCD
			movlw	'U'
			call	ToLCD
			movlw	'='
			call	ToLCD
			bcf		b_RS				; 
			movlw	b'10000110'			; 6  1 
			call	ToLCD				;
			bsf		b_RS				;  LCD
			movlw	'V'
			call	ToLCD
			
			bcf		b_RS				; 
			movlw	b'10001001'			; 9.  1 
			call	ToLCD				;
			bsf		b_RS				;  LCD
			movlw	'I'
			call	ToLCD
			movlw	'='
			call	ToLCD
			bcf		b_RS				; 
			movlw	b'10001111'			; 15  1 
			call	ToLCD				;
			bsf		b_RS				;  LCD
			movlw	'A'
			call	ToLCD
			
			movlw	.2
			movwf	metrCnt

			bcf		b_RS				;  LCD
			movlw	b'00001100'			;. LCD
			call	ToLCD				;
MAIN		
			bsf		T1CON, TMR1ON		;   
			clrwdt
			btfss	PIR1, TMR1IF		;
			goto	$-2					;
			bcf		T1CON, TMR1ON
			bcf		PIR1, TMR1IF
			movlw	0x0B				;3036 ->TMR1
			movwf	TMR1H				;65536-3036=62500*8=500000clk=250000us
			movlw	0xDC
			movwf	TMR1L

			bcf		fl_digval
			decfsz	metrCnt, F
			goto	$+4
			bsf		fl_digval
			movlw	.2
			movwf	metrCnt
			
			call	U2LCD
			call	I2LCD
			goto	MAIN

;======================================
U2LCD		bsf		ADCON0, CHS0		;  AN1
			bcf		b_RS				; 
			movlw	b'10000010'			;
			goto	AD2lcd
;			return
I2LCD		bcf		ADCON0, CHS0		;  AN0
			bcf		b_RS				; 
			movlw	b'10001011'			;
AD2lcd		call	ToLCD				;
			clrf	adL
			clrf	adM
			clrf	adH
			clrf	adHH
			
;  -      
; ,       
;-        
			movlw	.3
			movwf	adCnt
			movlw	0xFF
			movwf	adZ
			bcf		fl_tmp
zfind		call	delay_20us
			bsf		ADCON0, GO			; 
			btfsc	ADCON0, GO
			goto	$-1					;  
			
			movf	ADRESH, F			;      0
			btfss	STATUS, Z
			goto	zfind
			
			movf	adZ, W
			bsf		STATUS, RP0
			subwf	ADRESL, W			;ADRESL-adL
			bcf		STATUS, RP0
			btfss	STATUS, C
			goto	saveZ				;ADRESL<adL
;			btfss	STATUS, Z			;ADRESL>=adL
;			goto	zfind				;ADRESL>adL
			btfss	fl_tmp
			goto	zfind
			decfsz	adCnt, F			;ADRESL=adL
			goto	zfind
			goto	zwait
saveZ		bsf		STATUS, RP0			;ADRESL<adL
			movf	ADRESL, W
			bcf		STATUS, RP0
			movwf	adZ					;adZ=ADRESL	  0
			movlw	.3
			movwf	adCnt
			bsf		fl_tmp		
			goto	zfind
			
zwait		
			call	delay_20us
			bsf		ADCON0, GO			; 
			btfsc	ADCON0, GO
			goto	$-1					;  
			movf	ADRESH, F
			btfss	STATUS, Z
			goto	zwait
			bsf		STATUS, RP0
			movf	ADRESL, W			
			bcf		STATUS, RP0
			subwf	adZ, W				;adZ-ADRESL
			btfss	STATUS, C
			goto	zwait				; 0 .. ADRESL<=adZ and ADRESH=0
			
ADbeg		; 100      200us 100*200=20000us(  50Hz)
			movlw	.100
			movwf	adCnt
			
			call	delay_20us
			goto	$+4
ad2lcd0		clrwdt
			btfss	INTCON, T0IF
			goto	$-1					;  TMR0 (200us)
			movlw	.56
			movwf	TMR0
			bcf		INTCON, T0IF
			bsf		ADCON0, GO			; 
			btfsc	ADCON0, GO
			goto	$-1					;  
			decf	adCnt, F
			btfsc	STATUS, Z
			goto	ad2lcd1
			
			
	;   adH:adL < 3FFh
			movlw	0x03				;
			subwf	ADRESH, W			;H-03h
			btfss	STATUS, C
;			goto	justify				;
			goto	ad2lcd2				;H<03h
			movlw	0xFF
			bsf		STATUS, RP0
			subwf	ADRESL, W			;
			bcf		STATUS, RP0
			btfsc	STATUS, C
			goto	overload				;adL>=FFh
			
	;  -   0
justify		movf	adZ, W
			bsf		STATUS, RP0
			subwf	ADRESL, F
			bcf		STATUS, RP0
			btfsc	STATUS, C
			goto	ad2lcd2
			movlw	.1
			subwf	ADRESH, F
			btfsc	STATUS, C
			goto	ad2lcd2
			clrf	ADRESH
			bsf		STATUS, RP0
			clrf 	ADRESL
			bcf		STATUS, RP0
			
;  ( )

;   -   0,5(10   5,12 = 0,005  )
ad2lcd2	
			bcf		STATUS, C
			rrf		ADRESH, W
			
			movwf	REGA1
			movwf	REGB1
			clrf	REGA3
			clrf	REGB3
			clrf	REGA2
			clrf	REGB2
			bsf		STATUS, RP0
			rrf		ADRESL, W
			bcf		STATUS, RP0
			
			movwf	REGA0
			movwf	REGB0
			call	multiply		;   (REGA * REGB)  32  REGA
			
;32   ad=ad+REGA (adL, adM, adH, adHH)+(REGA3, REGA2, REGA1, REGA0) = (adL, adM, adH, adHH)
			movf    REGA0, W
        	addwf   adL, F		     ;
        	btfsc   STATUS, C        ; add in carry
        	incf    adM, F
        	movf    REGA1, W
        	addwf   adM, F		   	; add msb			
        	btfsc   STATUS, C       ; add in carry
        	incf    adH, F
        	movf    REGA2, W
        	addwf   adH, F       	;
        	btfsc   STATUS, C       ; add in carry
        	incf    adHH, F
        	movf    REGA3, W
        	addwf   adHH, F       	;

			goto	ad2lcd0			;
			
ad2lcd1
; -      
; adL,M,H,HH  (100/2=50)
       		movf	adL, W
			movwf	REGA0
       		movf	adM, W
			movwf	REGA1
       		movf	adH, W
			movwf	REGA2
       		movf	adHH, W
			movwf	REGA3
			movlw	.50
			movwf	REGB0			;W -> REGB
			clrf	REGB1
			clrf	REGB2
			clrf	REGB3
			call	divide			; (REGA/REGB=REGA (REGC)),   REGA
			call	round			; 

;If I then I=I/10^2
;			clrf	DivHi
;			btfsc	ADCON0, CHS0
;			goto	$+5
;			clrf	DivHi
;			movlw	.100
;			movwf	DivLo
;			call	Div24_16			;   -> ResHi, Mul1Hi, Mul1Lo
			
;   REGA     
			
;  -  () 
			
			call	sqrt				; ,   REGA
			clrwdt							;
			movf	REGA0, W			; REGA->ad
			movwf	adL
			movf	REGA1, W
			movwf	adM
			movf	REGA2, W
			movwf	adH
			movf	REGA3, W
			movwf	adHH
			call	bin2dec				;REGA -> DIGIT

			movf	adL, W				; ad->REGA
			movwf	REGA0
			movf	adM, W
			movwf	REGA1
			movf	adH, W
			movwf	REGA2
			movf	adHH, W
			movwf	REGA3
			call	setScale

			bsf		b_RS				;
			movlw	DIGIT8
			movwf	FSR

			btfss	fl_digval
			goto	num2lcd0
		;  		
			bsf		fl_tmp				;  
num2lcd		
			movf	INDF, W
			btfss	STATUS, Z
			bcf		fl_tmp
			btfsc	fl_tmp
			movlw	0xF0
			addlw	0x30
			call	ToLCD
			incf	FSR, F
			btfsc	ADCON0, CHS0
			goto	$+7
			movf	FSR, W
			sublw	DIGIT10
			btfss	STATUS, Z
			goto	$+3
			movlw	'.'
			call	ToLCD
			movf	FSR, W
			sublw	DIGIT10
			btfsc	STATUS, Z
			bcf		fl_tmp
			btfsc	STATUS, C
			goto	num2lcd
num2lcd0
			btfsc	ADCON0, CHS0		;if U
			call	Scale				;then Scale
			return
overload		
			bsf		b_RS				;
			movlw	' '
			call	ToLCD
			movlw	'!'
			call	ToLCD
			movlw	' '
			call	ToLCD
			movlw	' '
			call	ToLCD
			return
setScale
			clrf	ScaleSym
			movlw	.15					;15
			movwf	REGB0
			clrf	REGB1
			clrf	REGB2
			clrf	REGB3
			call	divide				;REGA/REGB->REGA(REGC)
			movf	REGA0, W			; 
;			movf	REGA1, W			;..   < 1  (U<255V)
			movwf	ScalePos			;   .  
			movf	REGC0, W			;
			btfsc	STATUS, Z			;  
			return
			movwf	REGA0				;   3
			clrf	REGA1
			clrf	REGA2
			clrf	REGA3
			movlw	.3
			movwf	REGB0
			clrf	REGB1
			clrf	REGB2
			clrf	REGB3
			call	divide
			movf	REGA0, W			;  
			movwf	ScaleSym			;
			return
Scale		movlw	.16
			movwf	tmp
			bcf		b_RS				; 
			movlw	b'11000000'			;   
			call	ToLCD				;
			bsf		b_RS
			movf	ScalePos, F			;  0
			btfsc	STATUS, Z
			goto	Sc2
Sc0			movlw	0xFF
			call	ToLCD				;
			decf	tmp, F
			btfsc	STATUS, Z
			return
			decfsz	ScalePos, F
			goto	Sc0
Sc2			movf	ScaleSym, F
			btfsc	STATUS, Z
			goto	Sc1
			decf	ScaleSym, W
			call	ToLCD
			decf	tmp, F
			btfsc	STATUS, Z
			return
Sc1			movlw	0x20
			call	ToLCD				;
			decfsz	tmp, F
			goto	Sc1
			return
			
;=========================
;    4      
;=========================
ToLCD		bcf		fl_lcdstep
			movwf	LCD_tmp
			movlw	b'11110000'			;  4..0
			andwf	LCD, F				;LCD   
			swapf	LCD_tmp, W
tolcd		andlw	b'00001111'
			iorwf	LCD, F
			bsf		b_E					;
			bcf		b_E					;---			
			btfsc	fl_lcdstep
			goto	tolcd0
			movlw	b'11110000'			;  4..0
			andwf	LCD, F				;LCD   
			movf	LCD_tmp, W
			bsf		fl_lcdstep
			goto	tolcd
tolcd0		
			call	delay_40us
			return

LCD_init	call	delay_40us
			movlw	b'00000011'		
			movwf	LCD
			bsf		b_E				;
			bcf		b_E				;---			
			call	delay_40us
			bsf		b_E				;
			bcf		b_E				;---			
			call	delay_40us
			bsf		b_E				;
			bcf		b_E				;---			
			call	delay_40us
			movlw	b'00000010'		;4bit mode
			movwf	LCD
			bsf		b_E				;
			bcf		b_E				;---			
			call	delay_40us
	
			bcf		b_RS				;   
			movlw	b'00101000'			;. 4 
			call	ToLCD				; 0- 
			
			movlw	b'00001000'			; 
			call	ToLCD
			
			movlw	b'00000001'			; 
			call	ToLCD
			call	delay_1600us
			
			movlw	b'00000110'			;  
			call	ToLCD				;  
			return

delay_20us
			movlw	.10
			movwf	cnt
			decfsz	cnt, F
			goto	$-1
			return
delay_40us
			movlw	.24
			movwf	cnt
			decfsz	cnt, F
			goto	$-1
			return
delay_1600us
			movlw	.72
			movwf	tmp
			call	delay_40us
			decfsz	tmp, F
			goto	$-2
			return

#include	"Math32.inc"

			end