;***************************************************************************************
;                -
;        (   2-    6-  ).
;***************************************************************************************
			cblock 0x45
			NUM0	    	     ;    
			NUM1	        	 ;
			NUM2                 ;
			NUM3                 ;
			NUM4                 ;
			NUM5                 ;

			Count                ;  .
			Mem                  ;

			ValueL
			ValueH         
			endc


Bin2_10     bcf		STATUS, C
            movlw	.16         ;    Count   ,
            movwf	Count
            
            clrf	NUM0
            clrf	NUM1
            clrf	NUM2
            clrf	NUM3
            clrf	NUM4
            clrf	NUM5
            
Loop16      rlf        ValueL,F
            rlf        ValueH,F

            rlf        NUM0,F
            rlf        NUM1,F
            rlf        NUM2,F

            decfsz     Count, F
            goto       adjDEC

            swapf      NUM2,W      ;    LED2
            andlw      0x0F        ;    LED5.
            movwf      NUM5        ; --------------------------------

            movfw      NUM2        ;    LED2
            andlw      0x0F        ;    LED4.
            movwf      NUM4        ; --------------------------------

            swapf      NUM1,W      ;    LED1
            andlw      0x0F        ;    LED3.
            movwf      NUM3        ; --------------------------------

            movfw      NUM1        ;    LED1
            andlw      0x0F        ;    LED2.
            movwf      NUM2        ; --------------------------------

            swapf      NUM0,W      ;    LED0
            andlw      0x0F        ;    LED1.
            movwf      NUM1        ; --------------------------------

            movfw      NUM0        ;    LED0
            andlw      0x0F        ;    LED0.
            movwf      NUM0        ; --------------------------------
            return                 

adjDEC      movlw      NUM0
            movwf      FSR
            call       adjBCD
            movlw      NUM1
            movwf      FSR
            call       adjBCD
            movlw      NUM2
            movwf      FSR
            call       adjBCD
            goto       Loop16

adjBCD      movlw      0x03
            addwf      INDF, W
            movwf      Mem
  
            btfsc      Mem,3
            movwf      .0

            movlw      0x30
            addwf      INDF, W
            movwf      Mem

            btfsc      Mem,7
            movwf      INDF 

            retlw      0x00
